<template>
  <Row class="investor-stock-code">
    <!-- stock data chart -->
    <i-col class="content-block" :lg="12" :md="12">
      <stock-tech-charts v-if="stockData"
                         :id="stockCode"
                         :stock-code="stockCode"
                         :data="stockData"
                         :chart-types="[ 'kd', 'vol', 'MACD', 'kd933' ]"
                         :sync-point="syncPoint"
                         :load-more-data-args="loadMoreDataArgs"
                         :kd-options="kdOptions"
                         :vol-options="volOptions"
                         :macd-options="macdOptions"
                         :kd933-options="kd933Options"
                         @on-point="broadcastPointAction"
                         @on-load-more-data="broadcastLoadMoreDataArgsAction">
      </stock-tech-charts>
    </i-col>
    <!-- daily information   -->
    <i-col class="content-block" :lg="12" :md="12">
      <Row class="news-block">
        <Row class="info-title">NEWS</Row>
        <a v-for="(news, index) in dailyNews" :key="`${timestamp}-${index}`"
           :href="news['url']" target="_blank">
          <Row class="news-item">
            <div class="news-date inline-block">{{ (new Date(news['timestamp'])).toLocaleDateString() }}</div>
            <div class="news-title inline-block overflow-dot"> {{ news['title'] }} </div>
          </Row>
        </a>
      </Row>
      <Row class="tags-block">
        <Row class="info-title">
          <div class="inline-block">TAG</div>
          <div class="inline-block">
            <input class="new-tag-input" v-model="newTag"
                   :placeholder="`new tag at ${currentDate}...`" @keyup.enter="addNewTagAction"></input>
          </div>
          <div class="inline-block">
            <div class="add-new-tag-btn div-btn" @click="addNewTagAction">
              <Icon type="md-add"></Icon>
            </div>
          </div>
        </Row>
        <Row>
          <i-col v-for="(tag, index) in dailyTags" :key="`${timestamp}-${index}`"
                 :lg="8" :md="12" :sm="24" :xs="24" style="padding: 10px">
            <Row class="tag-item">
              <div class="tag-name inline-block overflow-dot">{{tag.tagName}}</div>
              <div class="inline-block">
                <div class="remove-tag-btn div-btn" @click="removeTagAction(tag.id, index)">
                  <Icon type="md-trash"></Icon>
                </div>
              </div>
            </Row>
          </i-col>
        </Row>
      </Row>
    </i-col>
  </Row>
</template>

<script>
import StockTechCharts from "../../../../components/p5/StockTechCharts";
import {todayLocaleTimeStamp} from "../../../../helpers/utils";
import { validators as stockDataAPI } from '../../../../configs/request-validator/stock-data';
import { validators as newsAPI } from '../../../../configs/request-validator/company-news';
import { validators as tagAPI } from '../../../../configs/request-validator/user-daily-tag';

const actions = {
  broadcastPointAction(point) {
    this.syncPoint = point;
    if (point) {
      this.currentTimestamp = Number(point.key);
    }
  },
  broadcastLoadMoreDataArgsAction(args) {
    this.loadMoreDataArgs = {...args, flag: (new Date()).getTime()};
  },
  async addNewTagAction() {
    const requestData = {
      type: 'stockCode',
      companyId: null,
      stockCode: this.stockCode,
      timestamp: (this.currentTimestamp)
        ? Number(this.currentTimestamp)
        : todayLocaleTimeStamp(),
      tagName: this.newTag.toString(),
    };

    try {
      const { data } = await this.$api(tagAPI.AddNewDailyTagRequest, requestData);
      this.addNewTagIntoTagList(data);
      this.newTag = undefined;
      this.resetDataToShow();
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
  async removeTagAction(id, index) {
    const requestData = {
      userId: null,
      dailyTagId: id,
    };

    try {
      await this.$api(tagAPI.RemoveDailyTagRequest, requestData);
      this.tagList[this.currentTimestamp].splice(index, 1);
      this.resetDataToShow();
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
};

export default {
  name: 'index',
  components: {StockTechCharts},
  data() {
    return {
      // stockCode
      stockCode: undefined,
      // chart:
      stockData: undefined,
      syncPoint: undefined,
      loadMoreDataArgs: undefined,
      kdOptions: { height: '350px' },
      volOptions: { height: '250px' },
      macdOptions: { height: '250px' },
      kd933Options: { height: '250px' },
      // news:
      news: undefined,
      dailyNews: undefined,
      // tags:
      tagList: undefined,
      dailyTags: undefined,
      newTag: undefined,
      // timestamp
      currentTimestamp: undefined,
      timestamp: new Date().getTime(),
    };
  },
  computed: {
    currentDate() {
      const isViewedOnSpecialDate = !!this.currentTimestamp;
      return (isViewedOnSpecialDate)
        ? (new Date(this.currentTimestamp)).toLocaleDateString()
        : 'today';
    }
  },
  watch: {
    currentTimestamp(val, oldVal) {
      const isDifferent = val && val.toString() !== ((oldVal) ? oldVal.toString() : oldVal);
      if (isDifferent) {
        this.resetDataToShow();
      }
    }
  },
  methods: {
    ...actions,
    addNewTagIntoTagList(responseData) {
      // todo: check api, return success insert tags only
      Object.keys(responseData).forEach(key => {
        const tagListIncludeTimestamp = this.tagList.hasOwnProperty(key);
        const newTags = responseData[key];
        if (tagListIncludeTimestamp) {
          const originTags = this.tagList[key];
          this.tagList[key] = [ ...originTags, newTags ];
        } else {
          this.tagList[key] = [newTags];
        }
      });
    },
    resetDataToShow() {
      const isViewedOnSpecialDate = !!this.currentTimestamp;
      if (isViewedOnSpecialDate) {
        this.dailyNews = this.news[this.currentTimestamp] || [];
        this.dailyTags = [ ...(this.tagList[this.currentTimestamp] || []) ];
      } else {
        this.dailyNews = [];
        this.dailyTags = [];
      }
      this.forceRender();
    },
    forceRender() {
      this.timestamp = new Date().getTime();
    },
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
  async asyncData({ app, params}) {
    const stockCode = params['code'];
    let stockData = undefined;
    let news = {};
    let tagList = {};

    // requests
    const stockDataRequest = {
      stockCodes: [ stockCode ],
      startFrom: null,
      endAt: null,
    };
    const newsRequest = {
      type: "stockCode",
      companyId: null,
      stockCode,
      timestamp: null,
    };
    app.$conditionMutator(newsRequest, {});
    const tagRequest = {
      userId: null,
      type: 'stockCode',
      companyId: null,
      stockCode,
      startFrom: null,
      endAt: null,
      groupColumn: 'timestamp',
    };

    // invoke api
    try {
      const apiData = await Promise.all([
        app.$api(stockDataAPI.AccessByStockCodeRequest, stockDataRequest, undefined, false),
        app.$api(newsAPI.AccessDailyCompanyNewsRequest, newsRequest, undefined, false),
        app.$api(tagAPI.AccessDailyTadRequest, tagRequest, undefined, false),
      ]);

      // set vue data
      stockData = apiData[0]['data'][stockCode];
      news = apiData[1]['data'];
      tagList = apiData[2]['data'];
    } catch (error) {
      app.$apiErrorHandler(error);
    }
    return {
      stockCode,
      stockData,
      news,
      tagList
    };
  },
}
</script>

<style lang="scss" scoped>
  @import "../../../../assets/css/mixin";

  .investor-stock-code {
    height: 100%;
    text-align: center;
    .content-block {
      height: 100%;
      overflow-y: auto;
      overflow-x: hidden;
      padding: 30px 10px;
      .news-block {
        height: 60%;
        padding: 5px 10px;
        border-radius: 8px;
        overflow-y: auto;
        .news-item {
          padding: 5px 10px;
          margin-bottom: 10px;
          border-radius: 4px;
          font-size: 16px;
          .news-date {
            width: 120px;
          }
          .news-title {
            width: calc(100% - 130px);
            text-align: left;
          }
        }
      }
      .tags-block {
        height: calc(40% - 5px);
        padding: 5px 10px;
        border-radius: 8px;
        margin: 5px 0 0 0;
        overflow-y: auto;
        .tag-item {
          width: 100%;
          height: 30px;
          .tag-name {
            width: calc(100% - 40px);
            height: 100%;
            border-top-left-radius: 8px;
            border-bottom-left-radius: 8px;
            padding: 0 0 0 15px;
            line-height: 30px;
            vertical-align: middle;
            float: left;
            text-align: left;
          }
          .remove-tag-btn {
            width: 30px;
            height: 30px;
            border-radius: 0 8px 8px 0;
            margin-left: -5px;
            vertical-align: bottom;
            font-size: 20px;
            line-height: 26px;
            text-align: center;
            font-weight: bolder;
          }
        }
      }
      .info-title {
        font-size: 20px;
        padding: 10px 0;
        text-align: left;
        font-weight: bold;
        .new-tag-input {
          width: 220px;
          height: 32px;
          padding: 15px;
          border-top-left-radius: 8px;
          border-bottom-left-radius: 8px;
          border-right: 0;
          margin: 0 0 0 30px;
          font-size: 18px;
          vertical-align: bottom;
          &:focus {
            outline: none;
          }
        }
        .add-new-tag-btn {
          width: 32.5px;
          height: 32.5px;
          border-radius: 0 8px 8px 0;
          margin-left: -5px;
          vertical-align: bottom;
          font-size: 20px;
          line-height: 26px;
          text-align: center;
          font-weight: bolder;
        }
      }
    }
  }
</style>
